## percona-postgresql-17 17.2

=== contrib/pg_tde/Makefile ===
# contrib/pg_tde/Makefile

PGFILEDESC = "pg_tde access method"
MODULE_big = pg_tde
EXTENSION = pg_tde
DATA = pg_tde--1.0-beta2.sql

REGRESS_OPTS = --temp-config $(top_srcdir)/contrib/pg_tde/pg_tde.conf
REGRESS = toast_decrypt_basic \
toast_extended_storage_basic \
move_large_tuples_basic \
non_sorted_off_compact_basic \
update_compare_indexes_basic \
pg_tde_is_encrypted_basic \
test_issue_153_fix_basic \
multi_insert_basic \
update_basic \
subtransaction_basic \
trigger_on_view_basic \
change_access_method_basic \
insert_update_delete_basic \
keyprovider_dependency_basic \
vault_v2_test_basic \
alter_index_basic \
merge_join_basic \
tablespace_basic
TAP_TESTS = 1

OBJS = src/encryption/enc_tde.o \
src/encryption/enc_aes.o \
src/access/pg_tde_slot.o \
src/access/pg_tde_tdemap.o \
src$(MAJORVERSION)/access/pg_tde_io.o \
src$(MAJORVERSION)/access/pg_tdeam_visibility.o \
src$(MAJORVERSION)/access/pg_tdeam.o \
src$(MAJORVERSION)/access/pg_tdetoast.o \
src$(MAJORVERSION)/access/pg_tde_prune.o \
src$(MAJORVERSION)/access/pg_tde_vacuumlazy.o \
src$(MAJORVERSION)/access/pg_tde_visibilitymap.o \
src$(MAJORVERSION)/access/pg_tde_rewrite.o \
src$(MAJORVERSION)/access/pg_tdeam_handler.o \
src/access/pg_tde_ddl.o \
src/access/pg_tde_xlog.o \
src/access/pg_tde_xlog_encrypt.o \
src/transam/pg_tde_xact_handler.o \
src/keyring/keyring_curl.o \
src/keyring/keyring_file.o \
src/keyring/keyring_vault.o \
src/keyring/keyring_kmip.o \
src/keyring/keyring_kmip_ereport.o \
src/keyring/keyring_api.o \
src/catalog/tde_global_space.o \
src/catalog/tde_keyring.o \
src/catalog/tde_keyring_parse_opts.o \
src/catalog/tde_principal_key.o \
src/common/pg_tde_shmem.o \
src/common/pg_tde_utils.o \
src/smgr/pg_tde_smgr.o \
src/pg_tde_defs.o \
src/pg_tde_event_capture.o \
src/pg_tde.o \
src/libkmip/libkmip/src/kmip.o \
src/libkmip/libkmip/src/kmip_bio.o \
src/libkmip/libkmip/src/kmip_locate.o \
src/libkmip/libkmip/src/kmip_memset.o

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
override PG_CPPFLAGS += -I$(CURDIR)/src/include -I$(CURDIR)/src/libkmip/libkmip/include -I$(CURDIR)/src$(MAJORVERSION)/include
include $(PGXS)
else
subdir = contrib/pg_tde
top_builddir = ../..
override PG_CPPFLAGS += -I$(top_srcdir)/$(subdir)/src/include  -I$(top_srcdir)/$(subdir)/src/libkmip/libkmip/include -I$(top_srcdir)/$(subdir)/src$(MAJORVERSION)/include
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

override SHLIB_LINK += -lcurl -lcrypto -lssl

# Fetches typedefs list for PostgreSQL core and merges it with typedefs defined in this project.
# https://wiki.postgresql.org/wiki/Running_pgindent_on_non-core_code_or_development_code
update-typedefs:
	wget -q -O - "https://buildfarm.postgresql.org/cgi-bin/typedefs.pl?branch=REL_17_STABLE" | cat - typedefs.list | sort | uniq > typedefs-full.list

# Indents projects sources.
indent:
	pgindent --typedefs=typedefs-full.list --excludes=pgindent_excludes .

.PHONY: update-typedefs indent

=== contrib/pg_tde/documentation/requirements.txt ===

Markdown
mkdocs
mkdocs-versioning
mkdocs-macros-plugin
mkdocs-exclude
markdown-include
mkdocs-material
mkdocs-with-pdf
mkdocs-git-revision-date-localized-plugin
mkdocs-material-extensions
mkdocs-bootstrap-tables-plugin
mkdocs-section-index
mkdocs-htmlproofer-plugin
mkdocs-meta-descriptions-plugin
mike
mkdocs-glightbox
Pillow > 10.1.0

=== src/bin/pg_waldump/Makefile ===
# src/bin/pg_waldump/Makefile

PGFILEDESC = "pg_waldump - decode and display WAL"
PGAPPICON=win32

subdir = src/bin/pg_waldump
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

OBJS = \
	$(RMGRDESCOBJS) \
	$(WIN32RES) \
	compat.o \
	pg_waldump.o \
	rmgrdesc.o \
	xlogreader.o \
	xlogstats.o

override CPPFLAGS := -DFRONTEND $(CPPFLAGS)

ifeq ($(enable_percona_ext),yes)
# TODO: Ideally should be built in pg_tde as a static lib
include $(top_srcdir)/contrib/pg_tde/Makefile.tools

TDE_OBJS2 = $(TDE_OBJS:%=$(top_srcdir)/contrib/pg_tde/%)

OBJS += \
	$(top_srcdir)/src/fe_utils/simple_list.o \
	$(TDE_OBJS2)

override CPPFLAGS := -I$(top_srcdir)/contrib/pg_tde/src/include -I$(top_srcdir)/contrib/pg_tde/src/libkmip/libkmip/include $(CPPFLAGS)
endif

RMGRDESCSOURCES = $(sort $(notdir $(wildcard $(top_srcdir)/src/backend/access/rmgrdesc/*desc*.c)))
RMGRDESCOBJS = $(patsubst %.c,%.o,$(RMGRDESCSOURCES))


all: pg_waldump

pg_waldump: $(OBJS) | submake-libpgport
	$(CC) $(CFLAGS) $^ $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)

xlogreader.c: % : $(top_srcdir)/src/backend/access/transam/%
	rm -f $@ && $(LN_S) $< .

xlogstats.c: % : $(top_srcdir)/src/backend/access/transam/%
	rm -f $@ && $(LN_S) $< .

$(RMGRDESCSOURCES): % : $(top_srcdir)/src/backend/access/rmgrdesc/%
	rm -f $@ && $(LN_S) $< .

install: all installdirs
	$(INSTALL_PROGRAM) pg_waldump$(X) '$(DESTDIR)$(bindir)/pg_waldump$(X)'

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(bindir)'

uninstall:
	rm -f '$(DESTDIR)$(bindir)/pg_waldump$(X)'

clean distclean:
	rm -f pg_waldump$(X) $(OBJS) $(RMGRDESCSOURCES) xlogreader.c xlogstats.c
	rm -rf tmp_check

check:
	$(prove_check)

installcheck:
	$(prove_installcheck)

=== contrib/pg_tde/src/libkmip/CMakeLists.txt ===
cmake_minimum_required(VERSION  3.5.0)

if (POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif(POLICY CMP0048)

project(kmip C CXX)

set(KMIP_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

add_subdirectory(libkmip/src)
add_subdirectory(kmippp)

=== contrib/pg_tde/src/libkmip/kmippp/CMakeLists.txt ===

add_library(
  kmippp
  STATIC
  kmippp.cpp
  )

target_link_libraries(kmippp kmip)
set_property(TARGET kmippp PROPERTY POSITION_INDEPENDENT_CODE ON)

target_include_directories(
  kmippp PUBLIC
  $<BUILD_INTERFACE:${KMIP_SOURCE_DIR}/kmippp/>
  $<INSTALL_INTERFACE:include>
  )
set_target_properties(
  kmippp PROPERTIES PUBLIC_HEADER
  "kmippp.h"
  )


export(TARGETS kmip kmippp FILE "kmippp.cmake")

install(
  TARGETS kmippp
  EXPORT kmippp
  DESTINATION cmake
  ARCHIVE DESTINATION lib
  PUBLIC_HEADER DESTINATION include/
  LIBRARY DESTINATION lib)

macro(add_pp_demo name)
  add_executable(demo_pp_${name} demo_${name}.cpp)
  target_link_libraries(demo_pp_${name} kmippp)
endmacro()

add_pp_demo(create)
add_pp_demo(activate)
add_pp_demo(get)
add_pp_demo(get_name)
add_pp_demo(register)
add_pp_demo(locate)
add_pp_demo(all)

## percona-postgresql-17 17.0

=== debian/changelog ===
percona-postgresql-17 (17.0-1) unstable; urgency=medium

  * Update to new Percona Platform for PostgreSQL version 17.0-1

 -- root <root@568ea738d655>  Tue, 01 Oct 2024 09:25:42 -0400

percona-postgresql-17 (17.0) unstable; urgency=low
  * Initial Release.
 -- EvgeniyPatlan <evgeniy.patlan@percona.com> Tue, 01 Oct 2024 09:25:42 -0400

=== debian/control ===
Source: percona-postgresql-17
Section: database
Priority: optional
Maintainer: Percona Development Team <info@percona.com>
Standards-Version: 4.5.0
Rules-Requires-Root: no
Build-Depends:
 autoconf,
 bison,
 clang [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 debhelper,
 dh-exec (>= 0.13~),
 docbook-xml,
 docbook-xsl (>= 1.77),
 dpkg-dev (>= 1.16.1~),
 flex,
 gdb <!nocheck>,
 gettext,
 krb5-multidev,
 libedit-dev,
 libicu-dev,
 libio-pty-perl <!nocheck>,
 libipc-run-perl <!nocheck>,
 libkrb5-dev,
 libldap2-dev,
 liblz4-dev,
 libpam0g-dev | libpam-dev,
 libperl-dev,
 libreadline-dev,
 libselinux1-dev [linux-any],
 libssl-dev,
 libsystemd-dev [linux-any],
 libxml2-dev,
 libxml2-utils,
 libxslt1-dev,
 llvm-dev [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 mawk,
 perl (>= 5.8),
 pkg-config,
 python3-dev,
 systemtap-sdt-dev,
 tcl-dev,
 uuid-dev,
 xsltproc,
 zlib1g-dev | libz-dev
Homepage: http://www.postgresql.org/

Package: libpq-dev
Architecture: any
Section: libdevel
Depends:
 libpq5 (= ${binary:Version}),
 libssl-dev,
 ${misc:Depends},
 ${shlibs:Depends}
Suggests: percona-postgresql-doc-17
Description: header files for libpq5 (PostgreSQL library)
 Header files and static library for compiling C programs to link
 with the libpq library in order to communicate with a PostgreSQL
 database backend.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpq5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: PostgreSQL C client library
 libpq is a C library that enables user programs to communicate with
 the PostgreSQL database server.  The server can be on another machine
 and accessed through TCP/IP.  This version of libpq is compatible
 with servers from PostgreSQL 8.2 or later.
 .
 This package contains the run-time library, needed by packages using
 libpq.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg6
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: run-time library for ECPG programs
 The libecpg shared library is used by programs built with ECPG
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg-dev
Architecture: any
Section: libdevel
Depends:
 libecpg-compat3 (= ${binary:Version}),
 libecpg6 (= ${binary:Version}),
 libpgtypes3 (= ${binary:Version}),
 libpq-dev,
 ${misc:Depends},
 ${shlibs:Depends}
Description: development files for ECPG (Embedded PostgreSQL for C)
 This package contains the necessary files to build ECPG (Embedded
 PostgreSQL for C) programs.  It includes the development libraries
 and the preprocessor program ecpg.
 .
 PostgreSQL is an object-relational SQL database management system.
 .
 Install this package if you want to write C programs with SQL statements
 embedded in them (rather than run by an external process).

Package: libecpg-compat3
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: older version of run-time library for ECPG programs
 The libecpg_compat shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpgtypes3
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: shared library libpgtypes for PostgreSQL 17
 The libpgtypes shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: percona-postgresql-17
Architecture: any
Depends:
 locales | locales-all,
 percona-postgresql-client-17,
 percona-postgresql-common (>= 182~),
 ssl-cert,
 tzdata,
 curl,
 percona-pg-telemetry17,
 ${misc:Depends},
 ${shlibs:Depends}
Provides: percona-postgresql-contrib-17, postgresql-contrib-17 (= ${binary:Version}), postgresql-17 (= ${binary:Version})
Recommends: sysstat
Description: The World's Most Advanced Open Source Relational Database
 PostgreSQL, also known as Postgres, is a free and open-source relational
 database management system (RDBMS) emphasizing extensibility and SQL
 compliance. It features transactions with Atomicity, Consistency, Isolation,
 Durability (ACID) properties, automatically updatable views, materialized
 views, triggers, foreign keys, and stored procedures. It is designed to handle
 a range of workloads, from single machines to data warehouses or Web services
 with many concurrent users.
 .
 This package provides the database server for PostgreSQL 17.
XB-Postgresql-Catversion: ${postgresql:Catversion}

Package: percona-postgresql-client-17
Architecture: any
Multi-Arch: foreign
Depends:
 libpq5 (>= ${source:Upstream-Version}),
 postgresql-client-common (>= 182~),
 sensible-utils,
 ${misc:Depends},
 ${shlibs:Depends}
Suggests: percona-postgresql-17, percona-postgresql-doc-17
Provides: percona-postgresql-client, postgresql-client (= ${binary:Version}), postgresql-client-17 (= ${binary:Version})
Conflicts: postgresql-server-dev-17 (<< 17.0-1~)
Replaces: postgresql-server-dev-17 (<< 17.0-1~)
Description: front-end programs for PostgreSQL 17
 This package contains client and administrative programs for
 PostgreSQL: these are the interactive terminal client psql and
 programs for creating and removing users and databases.
 .
 This is the client package for PostgreSQL 17. If you install
 PostgreSQL 17 on a standalone machine, you need the server package
 postgresql-17, too. On a network, you can install this package on
 many client machines, while the server package may be installed on
 only one machine.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: percona-postgresql-server-dev-17
Architecture: any
Section: libdevel
Depends:
 clang [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 libpq-dev (>= 17~~),
 llvm-dev [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 percona-postgresql-client-17, percona-postgresql-common (>= 162~),
 ${misc:Depends},
 ${shlibs:Depends}
Breaks:
 postgresql-server-dev-all (<< 181~)
Provides: postgresql-server-dev-all, postgresql-server-dev-all-17
Description: development files for PostgreSQL 17 server-side programming
 Header files for compiling SSI code to link into PostgreSQL's backend; for
 example, for C functions to be called from SQL.
 .
 This package also contains the Makefiles necessary for building add-on
 modules of PostgreSQL, which would otherwise have to be built in the
 PostgreSQL source-code tree.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: percona-postgresql-doc-17
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Breaks: postgresql-common (<< 158~)
Description: documentation for the PostgreSQL database management system
 This package contains all README files, user manual, and examples for
 PostgreSQL 17. The manual is in HTML format.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: percona-postgresql-plperl-17
Architecture: any
Depends:
 perl,
 percona-postgresql-17 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Breaks: percona-postgresql-17 (<< 17~beta1)
Replaces: percona-postgresql-17 (<< 17~beta1)
Provides: percona-postgresql-plperl, postgresql-plperl, postgresql-plperl-17
Description: PL/Perl procedural language for PostgreSQL 17
 PL/Perl enables an SQL developer to write procedural language functions
 for PostgreSQL 17 in Perl.  You need this package if you have any
 PostgreSQL 17 functions that use the languages plperl or plperlu.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: percona-postgresql-plpython3-17
Architecture: any
Depends:
 percona-postgresql-17 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Breaks: percona-postgresql-17 (<< 17~beta1)
Replaces: percona-postgresql-17 (<< 17~beta1)
Provides: postgresql-plpython3,postgresql-plpython3-17, percona-postgresql-plpython3
Description: PL/Python 3 procedural language for PostgreSQL 17
 PL/Python 3 enables an SQL developer to write procedural language functions
 for PostgreSQL 17 in Python 3.  You need this package if you have any
 PostgreSQL 17 functions that use the languages plpython3 or plpython3u.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: percona-postgresql-pltcl-17
Architecture: any
Depends:
 percona-postgresql-17 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Provides: percona-postgresql-pltcl, postgresql-pltcl, postgresql-17-pltcl
Description: PL/Tcl procedural language for PostgreSQL 17
 PL/Tcl enables an SQL developer to write procedural language functions
 for PostgreSQL 17 in Tcl.  You need this package if you have any
 PostgreSQL 17 functions that use the languages pltcl or pltclu.
 .
 PostgreSQL is an object-relational SQL database management system.

=== debian/rules ===
#!/usr/bin/make -f

# The PostgreSQL server packages include this in their debian/rules file.
MAJOR_VER = 17
ifndef MAJOR_VER
$(error MAJOR_VER must be defined before including this file)
endif

# path to auxiliary build files
AUX_MK_DIR = /usr/share/postgresql-common/server

# version comparison
version_ge = $(shell dpkg --compare-versions $(MAJOR_VER) ge $(1) && echo y)

# include dpkg makefiles
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# strict symbol checking
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# server catalog version
CATVERSION = $(shell awk '/CATALOG_VERSION_NO/ { print $$3 }' src/include/catalog/catversion.h)

# configure flags

CONFIGURE_FLAGS = \
  --with-tcl \
  --with-perl \
  --with-python \
  --with-pam \
  --with-openssl \
  --with-libxml \
  --with-libxslt \
  --mandir=/usr/share/postgresql/$(MAJOR_VER)/man \
  --docdir=/usr/share/doc/postgresql-doc-$(MAJOR_VER) \
  --sysconfdir=/etc/postgresql-common \
  --datarootdir=/usr/share/ \
  --datadir=/usr/share/postgresql/$(MAJOR_VER) \
  --bindir=/usr/lib/postgresql/$(MAJOR_VER)/bin \
  --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/ \
  --libexecdir=/usr/lib/postgresql/ \
  --includedir=/usr/include/postgresql/ \
  --enable-nls \
  --enable-thread-safety \
  --enable-debug \
  --enable-dtrace \
  --disable-rpath \
  --with-uuid=e2fs \
  --with-gnu-ld \
  --with-gssapi \
  --with-ldap \
  --with-pgport=5432 \
  --with-system-tzdata=/usr/share/zoneinfo \
  AWK=mawk \
  MKDIR_P='/bin/mkdir -p' \
  PROVE='/usr/bin/prove' \
  PYTHON=/usr/bin/python3 \
  TAR='/bin/tar' \
  XSLTPROC='xsltproc --nonet' \
  CFLAGS='$(CFLAGS)' \
  LDFLAGS='$(LDFLAGS)'

ifeq ($(call version_ge,9.4),y)
  CONFIGURE_FLAGS += --enable-tap-tests
endif

ifeq ($(call version_ge,9.5),y)
  ifneq ($(findstring $(DEB_HOST_ARCH), alpha),)
    CONFIGURE_FLAGS += --disable-spinlocks
  endif
endif

ifeq ($(call version_ge,10),y)
  CONFIGURE_FLAGS += --with-icu
endif

ifeq ($(call version_ge,11),y)
  # if LLVM is installed, use it
  ifneq ($(wildcard /usr/bin/llvm-config-*),)
    LLVM_CONFIG = $(lastword $(sort $(wildcard /usr/bin/llvm-config-*)))
    LLVM_VERSION = $(subst /usr/bin/llvm-config-,,$(LLVM_CONFIG))
    CONFIGURE_FLAGS += --with-llvm LLVM_CONFIG=$(LLVM_CONFIG) CLANG=/usr/bin/clang-$(LLVM_VERSION)
  else
    LLVM_VERSION = 0.invalid # mute dpkg error on empty version fields in debian/control
  endif
  TEMP_CONFIG = TEMP_CONFIG=$(AUX_MK_DIR)/test-with-jit.conf
endif

ifeq ($(call version_ge,17),y)
  CONFIGURE_FLAGS += --with-lz4
endif

# Facilitate hierarchical profile generation on amd64 (#730134)
ifeq ($(DEB_HOST_ARCH),amd64)
  CFLAGS += -fno-omit-frame-pointer
endif

# Work around an ICE bug in GCC 11.2.0, see
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=103395
ifneq ($(findstring $(DEB_HOST_ARCH), armel armhf),)
  CFLAGS+= -DSTAP_SDT_ARG_CONSTRAINT=g
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  CONFIGURE_FLAGS += --with-systemd
  CONFIGURE_FLAGS += --with-selinux
endif

ifneq ($(filter pkg.postgresql.cassert,$(DEB_BUILD_PROFILES)),)
  CONFIGURE_FLAGS += --enable-cassert
  GENCONTROL_FLAGS += -Vcassert='$${Newline}$${Newline}This package has been built with cassert enabled.'
endif

# hurd implemented semaphores only recently and tests still fail a lot
# plperl fails on kfreebsd-* (#704802)
ifneq ($(filter hurd kfreebsd,$(DEB_HOST_ARCH_OS)),)
  TEST_FAIL_COMMAND = exit 0
else
  TEST_FAIL_COMMAND = exit 0
endif

# recipes

%:
	dh $@

override_dh_builddeb:
	dh_builddeb -- -Zgzip

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build -- $(CONFIGURE_FLAGS)
	# remove pre-built documentation
	rm -fv doc/src/sgml/*-stamp

	#cd contrib/pg_tde; \
	#	./configure; \
	#	cd -

override_dh_auto_build-indep:
	$(MAKE) -C build/doc all # build man + html

override_dh_auto_build-arch:
	# set MAKELEVEL to 0 to force building submake-generated-headers in src/Makefile.global(.in)
	MAKELEVEL=0 $(MAKE) -C build/src all
	$(MAKE) -C build/doc man # build man only
	$(MAKE) -C build/config all
	#cp contrib/pg_tde/Makefile build/contrib/pg_tde
	$(MAKE) -C build/contrib all
	# build tutorial stuff
	$(MAKE) -C build/src/tutorial NO_PGXS=1
	$(MAKE) -C build/src/tools/pg_bsd_indent

override_dh_auto_install-arch:
	$(MAKE) -C build/doc/src/sgml install-man DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C build/src install DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C build/config install DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C build/contrib install DESTDIR=$(CURDIR)/debian/tmp
	# move SPI examples into server package (they wouldn't be in the doc package in an -A build)
	mkdir -p debian/postgresql-$(MAJOR_VER)/usr/share/doc/postgresql-$(MAJOR_VER)
	mkdir -p debian/postgresql-$(MAJOR_VER)/usr/share/doc/postgresql-$(MAJOR_VER)/examples/extension/
	mv -f debian/tmp/usr/share/doc/postgresql-doc-$(MAJOR_VER)/extension/* debian/postgresql-$(MAJOR_VER)/usr/share/doc/postgresql-$(MAJOR_VER)/examples/extension/
	$(MAKE) -C build/src/tools/pg_bsd_indent install DESTDIR=$(CURDIR)/debian/tmp
	install -m755 src/tools/pgindent/pgindent $(CURDIR)/debian/tmp/usr/lib/postgresql/$(MAJOR_VER)/bin
	install -m644 src/tools/pgindent/typedefs.list $(CURDIR)/debian/tmp/usr/share/postgresql/$(MAJOR_VER)

override_dh_auto_install-indep:
	$(MAKE) -C build/doc install DESTDIR=$(CURDIR)/debian/tmp

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/postgresql/$(MAJOR_VER)

override_dh_auto_clean:
	rm -rf build

override_dh_installchangelogs:
	dh_installchangelogs HISTORY

override_dh_compress:
	dh_compress -X.source -X.c
	# compress manpages (excluding debian/tmp/)
	gzip -9n $(CURDIR)/debian/*-*/usr/share/postgresql/*/man/man*/*.[137]

override_dh_install-arch:
	dh_install -a

	# link README.Debian.gz to postgresql-common
	mkdir -p debian/percona-postgresql-$(MAJOR_VER)/usr/share/doc/postgresql-$(MAJOR_VER)
	ln -s ../percona-postgresql-common/README.Debian.gz debian/percona-postgresql-$(MAJOR_VER)/usr/share/doc/postgresql-$(MAJOR_VER)/README.Debian.gz

	# assemble perl version of pg_config in libpq-dev
	cp debian/percona-postgresql-client-17/usr/lib/postgresql/17/bin/pg_config debian/libpq-dev/usr/bin/
	sed -ne '1,/__DATA__/p' debian/libpq-dev/usr/bin/pg_config
	LC_ALL=C debian/percona-postgresql-client-$(MAJOR_VER)/usr/lib/postgresql/$(MAJOR_VER)/bin/pg_config >> debian/libpq-dev/usr/bin/pg_config
	LC_ALL=C debian/percona-postgresql-client-$(MAJOR_VER)/usr/lib/postgresql/$(MAJOR_VER)/bin/pg_config --help >> debian/libpq-dev/usr/bin/pg_config
	chmod 755 debian/libpq-dev/usr/bin/pg_config

	# remove actual build path from Makefile.global for reproducibility
	sed -i -e "s!^abs_top_builddir.*!abs_top_builddir = /build/percona-postgresql-$(MAJOR_VER)/build!" \
	       -e "s!^abs_top_srcdir.*!abs_top_srcdir = /build/percona-postgresql-$(MAJOR_VER)/build/..!" \
	       -e 's!-f\(debug\|file\)-prefix-map=[^ ]* !!g' \
	       debian/percona-postgresql-client-$(MAJOR_VER)/usr/lib/postgresql/$(MAJOR_VER)/lib/pgxs/src/Makefile.global

	# these are shipped in the pl packages
	bash -c "rm -v debian/percona-postgresql-$(MAJOR_VER)/usr/share/postgresql/$(MAJOR_VER)/extension/{plperl,plpython,pltcl,*_pl}*"
	bash -c "rm -v debian/percona-postgresql-$(MAJOR_VER)/usr/lib/postgresql/$(MAJOR_VER)/lib/{plperl,plpython,pltcl,*_pl}*"
	bash -c "rm -rfv debian/percona-postgresql-$(MAJOR_VER)/usr/lib/postgresql/$(MAJOR_VER)/lib/bitcode/*{plperl,plpython,pltcl}*"

	# record catversion in a file
	echo $(CATVERSION) > debian/percona-postgresql-$(MAJOR_VER)/usr/share/postgresql/$(MAJOR_VER)/catalog_version

override_dh_install-indep:
	dh_install -i

	if [ -d debian/percona-postgresql-doc-$(MAJOR_VER) ]; then set -e; \
	     install -d debian/percona-postgresql-doc-$(MAJOR_VER)/usr/share/doc/postgresql-doc-$(MAJOR_VER)/tutorial; \

## percona-postgresql-17 17.2

=== debian/changelog ===
percona-postgresql-17 (17.2-1) unstable; urgency=medium

  * Update to new Percona Platform for PostgreSQL version 17.2-1

 -- root <root@43e1a16a90b8>  Tue, 24 Dec 2024 09:53:21 -0500

percona-postgresql-17 (17.2) unstable; urgency=low
  * Initial Release.
 -- EvgeniyPatlan <evgeniy.patlan@percona.com> Tue, 24 Dec 2024 09:53:21 -0500

## percona-postgresql-17 17.4

=== rpm/Makefile ===
#################################
# RPM-specific Makefile		#
# https://yum.postgresql.org	#
#                         	#
# Devrim Gunduz			#
# devrim@gunduz.org		#
#################################

# Predefined values

ARCH=`rpm --eval "%{_arch}"`
DIR=`pwd`
DIST=.f99
SPECFILE="postgresql-17.spec"

# Now, include global Makefile
include ../../../../global/Makefile.global

=== src/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src
#
# Copyright (c) 1994, Regents of the University of California
#
# src/Makefile
#
#-------------------------------------------------------------------------

subdir = src
top_builddir = ..
include Makefile.global

SUBDIRS = \
	common \
	port \
	timezone \
	backend \
	backend/utils/mb/conversion_procs \
	backend/snowball \
	include \
	interfaces \
	backend/replication/libpqwalreceiver \
	backend/replication/pgoutput \
	fe_utils \
	libtde \
	bin \
	pl \
	makefiles \
	test/regress \
	test/isolation \
	test/perl

ifeq ($(with_llvm), yes)
SUBDIRS += backend/jit/llvm
endif

# There are too many interdependencies between the subdirectories, so
# don't attempt parallel make here.
.NOTPARALLEL:

$(recurse)

install: install-local

install-local: installdirs-local
	$(INSTALL_DATA) Makefile.global '$(DESTDIR)$(pgxsdir)/$(subdir)/Makefile.global'
	$(INSTALL_DATA) Makefile.port '$(DESTDIR)$(pgxsdir)/$(subdir)/Makefile.port'
	$(INSTALL_DATA) $(srcdir)/Makefile.shlib '$(DESTDIR)$(pgxsdir)/$(subdir)/Makefile.shlib'
	$(INSTALL_DATA) $(srcdir)/nls-global.mk '$(DESTDIR)$(pgxsdir)/$(subdir)/nls-global.mk'

installdirs: installdirs-local

installdirs-local:
	$(MKDIR_P) '$(DESTDIR)$(pgxsdir)/$(subdir)'

uninstall: uninstall-local

uninstall-local:
	rm -f $(addprefix '$(DESTDIR)$(pgxsdir)/$(subdir)'/, Makefile.global Makefile.port Makefile.shlib nls-global.mk)

clean:
	$(MAKE) -C test $@
	$(MAKE) -C tutorial NO_PGXS=1 $@
	$(MAKE) -C test/isolation $@
	$(MAKE) -C tools/pg_bsd_indent $@

distclean:
	$(MAKE) -C test $@
	$(MAKE) -C tutorial NO_PGXS=1 $@
	$(MAKE) -C test/isolation $@
	$(MAKE) -C tools/pg_bsd_indent $@
	rm -f Makefile.port Makefile.global


.PHONY: install-local installdirs-local uninstall-local

=== contrib/pg_tde/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 PGFILEDESC = "pg_tde access method"
 MODULE_big = pg_tde
 EXTENSION = pg_tde
-DATA = pg_tde--1.0-beta2.sql
+DATA = pg_tde--1.0-rc.sql
 
 REGRESS_OPTS = --temp-config $(top_srcdir)/contrib/pg_tde/pg_tde.conf
 REGRESS = toast_decrypt_basic \
@@ -23,7 +23,10 @@
 vault_v2_test_basic \
 alter_index_basic \
 merge_join_basic \
-tablespace_basic
+tablespace_basic \
+relocate \
+version \
+recreate_storage
 TAP_TESTS = 1
 
 OBJS = src/encryption/enc_tde.o \
@@ -49,7 +52,6 @@
 src/keyring/keyring_kmip.o \
 src/keyring/keyring_kmip_ereport.o \
 src/keyring/keyring_api.o \
-src/catalog/tde_global_space.o \
 src/catalog/tde_keyring.o \
 src/catalog/tde_keyring_parse_opts.o \
 src/catalog/tde_principal_key.o \
@@ -58,6 +60,7 @@
 src/smgr/pg_tde_smgr.o \
 src/pg_tde_defs.o \
 src/pg_tde_event_capture.o \
+src/pg_tde_guc.o \
 src/pg_tde.o \
 src/libkmip/libkmip/src/kmip.o \
 src/libkmip/libkmip/src/kmip_bio.o \

=== src/bin/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/bin (client programs)
#
# Portions Copyright (c) 1996-2024, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
# src/bin/Makefile
#
#-------------------------------------------------------------------------

subdir = src/bin
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

include $(top_srcdir)/contrib/pg_tde/Makefile.tools

export TDE_OBJS
export TDE_XLOG_OBJS

SUBDIRS = \
	initdb \
	pg_amcheck \
	pg_archivecleanup \
	pg_basebackup \
	pg_checksums \
	pg_combinebackup \
	pg_config \
	pg_controldata \
	pg_ctl \
	pg_dump \
	pg_resetwal \
	pg_rewind \
	pg_tde_change_key_provider \
	pg_test_fsync \
	pg_test_timing \
	pg_upgrade \
	pg_verifybackup \
	pg_waldump \
	pg_walsummary \
	pgbench \
	psql \
	scripts

ifeq ($(PORTNAME), win32)
SUBDIRS += pgevent
else
ALWAYS_SUBDIRS += pgevent
endif

all: tdelibs

$(recurse)
$(recurse_always)

=== src/libtde/Makefile ===

subdir = src/libtde
top_builddir = ../..

include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/pg_tde/Makefile.tools
 
all: tdelibs

install: all

=== contrib/pg_tde/documentation/requirements.txt ===
--- 
+++ 
@@ -16,3 +16,4 @@
 mike
 mkdocs-glightbox
 Pillow > 10.1.0
+mkdocs-open-in-new-tab

=== src/bin/pg_tde_change_key_provider/Makefile ===
# src/bin/pg_tde_change_key_provider/Makefile

PGFILEDESC = "pg_tde_change_key_provider"

subdir = src/bin/pg_tde_change_key_provider
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

OBJS = \
	pg_tde_change_key_provider.o 

override CPPFLAGS := -DFRONTEND $(CPPFLAGS)

OBJS += \
	$(top_srcdir)/src/fe_utils/simple_list.o \
	$(top_builddir)/src/libtde/libtde.a

override CPPFLAGS := -I$(top_srcdir)/contrib/pg_tde/src/include -I$(top_srcdir)/contrib/pg_tde/src/libkmip/libkmip/include $(CPPFLAGS)

all: pg_tde_change_key_provider

pg_tde_change_key_provider: $(OBJS) | submake-libpgport
	$(CC) $(CFLAGS) $^ $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)

install: all installdirs
	$(INSTALL_PROGRAM) pg_tde_change_key_provider$(X) '$(DESTDIR)$(bindir)/pg_tde_change_key_provider$(X)'

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(bindir)'

uninstall:
	rm -f '$(DESTDIR)$(bindir)/pg_tde_change_key_provider$(X)'

clean distclean:
	rm -f pg_tde_change_key_provider$(X) $(OBJS) $(RMGRDESCSOURCES) xlogreader.c xlogstats.c
	rm -rf tmp_check

=== debian/changelog ===
percona-postgresql-17 (17.4-1) unstable; urgency=medium

  * Update to new Percona Platform for PostgreSQL version 17.4-1

 -- root <root@f3c476fd27b0>  Tue, 25 Mar 2025 09:55:39 -0400

percona-postgresql-17 (17.4) unstable; urgency=low
  * Initial Release.
 -- EvgeniyPatlan <evgeniy.patlan@percona.com> Tue, 25 Mar 2025 09:55:39 -0400

=== debian/control ===
--- 
+++ 
@@ -171,8 +171,8 @@
  ${shlibs:Depends}
 Suggests: percona-postgresql-17, percona-postgresql-doc-17
 Provides: percona-postgresql-client, postgresql-client (= ${binary:Version}), postgresql-client-17 (= ${binary:Version})
-Conflicts: postgresql-server-dev-17 (<< 17.0-1~)
-Replaces: postgresql-server-dev-17 (<< 17.0-1~)
+Conflicts: postgresql-server-dev-17 (<< 17.4-1~)
+Replaces: postgresql-server-dev-17 (<< 17.4-1~)
 Description: front-end programs for PostgreSQL 17
  This package contains client and administrative programs for
  PostgreSQL: these are the interactive terminal client psql and

## percona-postgresql-17 17.5

=== contrib/pg_tde/documentation/requirements.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-
 Markdown
 mkdocs
 mkdocs-versioning
@@ -15,5 +14,7 @@
 mkdocs-meta-descriptions-plugin
 mike
 mkdocs-glightbox
-Pillow > 10.1.0
+Pillow > 10.1.0 # Pillow is required for mkdocs-glightbox
+mkdocs-open-in-new-tab # added to fix the open in new tab issue with mkdocs-material
 mkdocs-open-in-new-tab
+mkdocs-print-site-plugin

=== src/bin/pg_checksums/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/bin/pg_checksums
#
# Copyright (c) 1998-2024, PostgreSQL Global Development Group
#
# src/bin/pg_checksums/Makefile
#
#-------------------------------------------------------------------------

PGFILEDESC = "pg_checksums - verify data checksums in an offline cluster"
PGAPPICON=win32

subdir = src/bin/pg_checksums
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

# We need libpq only because fe_utils does.
LDFLAGS_INTERNAL += -L$(top_builddir)/src/fe_utils -lpgfeutils $(libpq_pgport)

OBJS = \
	$(WIN32RES) \
	pg_checksums.o

ifeq ($(enable_percona_ext),yes)
OBJS += \
	$(top_srcdir)/src/fe_utils/simple_list.o \
	$(top_builddir)/src/libtde/libtde.a

override CPPFLAGS := -I$(top_srcdir)/contrib/pg_tde/src/include -I$(top_srcdir)/contrib/pg_tde/src/libkmip/libkmip/include $(CPPFLAGS)
endif

all: pg_checksums

pg_checksums: $(OBJS) | submake-libpgport
	$(CC) $(CFLAGS) $^ $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)

install: all installdirs
	$(INSTALL_PROGRAM) pg_checksums$(X) '$(DESTDIR)$(bindir)/pg_checksums$(X)'

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(bindir)'

uninstall:
	rm -f '$(DESTDIR)$(bindir)/pg_checksums$(X)'

clean distclean:
	rm -f pg_checksums$(X) $(OBJS)
	rm -rf tmp_check

check:
	$(prove_check)

installcheck:
	$(prove_installcheck)

=== src/bin/pg_resetwal/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/bin/pg_resetwal
#
# Copyright (c) 1998-2024, PostgreSQL Global Development Group
#
# src/bin/pg_resetwal/Makefile
#
#-------------------------------------------------------------------------

PGFILEDESC = "pg_resetwal - reset PostgreSQL WAL log"
PGAPPICON=win32

subdir = src/bin/pg_resetwal
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

LDFLAGS_INTERNAL += -L$(top_builddir)/src/fe_utils -lpgfeutils

OBJS = \
	$(WIN32RES) \
	pg_resetwal.o

ifeq ($(enable_percona_ext),yes)
override CPPFLAGS := -DFRONTEND $(CPPFLAGS)

OBJS += \
	$(top_srcdir)/src/fe_utils/simple_list.o \
	$(top_builddir)/src/libtde/libtdexlog.a \
	$(top_builddir)/src/libtde/libtde.a \
	xlogreader.o

override CPPFLAGS := -I$(top_srcdir)/contrib/pg_tde/src/include -I$(top_srcdir)/contrib/pg_tde/src/libkmip/libkmip/include $(CPPFLAGS)
endif

all: pg_resetwal

xlogreader.c: % : $(top_srcdir)/src/backend/access/transam/%
	rm -f $@ && $(LN_S) $< .

pg_resetwal: $(OBJS) | submake-libpgport
	$(CC) $(CFLAGS) $^ $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)

install: all installdirs
	$(INSTALL_PROGRAM) pg_resetwal$(X) '$(DESTDIR)$(bindir)/pg_resetwal$(X)'

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(bindir)'

uninstall:
	rm -f '$(DESTDIR)$(bindir)/pg_resetwal$(X)'

clean distclean:
	rm -f pg_resetwal$(X) $(OBJS) xlogreader.c
	rm -rf tmp_check

check:
	$(prove_check)

installcheck:
	$(prove_installcheck)

=== src/bin/pg_waldump/Makefile ===
--- 
+++ 
@@ -19,14 +19,11 @@
 override CPPFLAGS := -DFRONTEND $(CPPFLAGS)
 
 ifeq ($(enable_percona_ext),yes)
-# TODO: Ideally should be built in pg_tde as a static lib
-include $(top_srcdir)/contrib/pg_tde/Makefile.tools
-
-TDE_OBJS2 = $(TDE_OBJS:%=$(top_srcdir)/contrib/pg_tde/%)
 
 OBJS += \
 	$(top_srcdir)/src/fe_utils/simple_list.o \
-	$(TDE_OBJS2)
+	$(top_builddir)/src/libtde/libtdexlog.a \
+	$(top_builddir)/src/libtde/libtde.a
 
 override CPPFLAGS := -I$(top_srcdir)/contrib/pg_tde/src/include -I$(top_srcdir)/contrib/pg_tde/src/libkmip/libkmip/include $(CPPFLAGS)
 endif

=== src/backend/access/heap/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile--
#    Makefile for access/heap
#
# IDENTIFICATION
#    src/backend/access/heap/Makefile
#
#-------------------------------------------------------------------------

subdir = src/backend/access/heap
top_builddir = ../../../..
include $(top_builddir)/src/Makefile.global

OBJS = \
	heapam.o \
	heapam_handler.o \
	heapam_visibility.o \
	heaptoast.o \
	hio.o \
	pruneheap.o \
	rewriteheap.o \
	vacuumlazy.o \
	visibilitymap.o

include $(top_srcdir)/src/backend/common.mk

=== src/backend/utils/misc/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile--
#    Makefile for utils/misc
#
# IDENTIFICATION
#    src/backend/utils/misc/Makefile
#
#-------------------------------------------------------------------------

subdir = src/backend/utils/misc
top_builddir = ../../../..
include $(top_builddir)/src/Makefile.global

override CPPFLAGS := -I. -I$(srcdir) $(CPPFLAGS)

OBJS = \
	conffiles.o \
	guc.o \
	guc-file.o \
	guc_funcs.o \
	guc_tables.o \
	help_config.o \
	injection_point.o \
	percona.o \
	pg_config.o \
	pg_controldata.o \
	pg_rusage.o \
	ps_status.o \
	queryenvironment.o \
	rls.o \
	sampling.o \
	superuser.o \
	timeout.o \
	tzparser.o

# This location might depend on the installation directories. Therefore
# we can't substitute it into pg_config.h.
ifdef krb_srvtab
override CPPFLAGS += -DPG_KRB_SRVTAB='"$(krb_srvtab)"'
endif

include $(top_srcdir)/src/backend/common.mk

clean:
	rm -f guc-file.c

=== debian/changelog ===
percona-postgresql-17 (17.5-3) unstable; urgency=medium

  * Update to new Percona Platform for PostgreSQL version 17.5-3

 -- root <root@b36916c05a39>  Tue, 26 Aug 2025 11:09:26 -0400

percona-postgresql-17 (17.5) unstable; urgency=low
  * Initial Release.
 -- EvgeniyPatlan <evgeniy.patlan@percona.com> Tue, 26 Aug 2025 11:09:26 -0400

=== debian/control ===
--- 
+++ 
@@ -171,8 +171,8 @@
  ${shlibs:Depends}
 Suggests: percona-postgresql-17, percona-postgresql-doc-17
 Provides: percona-postgresql-client, postgresql-client (= ${binary:Version}), postgresql-client-17 (= ${binary:Version})
-Conflicts: postgresql-server-dev-17 (<< 17.4-1~)
-Replaces: postgresql-server-dev-17 (<< 17.4-1~)
+Conflicts: postgresql-server-dev-17 (<< 17.5-1~)
+Replaces: postgresql-server-dev-17 (<< 17.5-1~)
 Description: front-end programs for PostgreSQL 17
  This package contains client and administrative programs for
  PostgreSQL: these are the interactive terminal client psql and
